package ru.dbotthepony.kstarbound.client.gl

import org.lwjgl.opengl.GL46.*
import ru.dbotthepony.kstarbound.client.StarboundClient

class VertexArrayObject {
	val client = StarboundClient.current()
	val pointer = glGenVertexArrays()

	init {
		checkForGLError()
		client.registerCleanable(this, ::glDeleteVertexArrays, pointer)
	}

	fun bind(): VertexArrayObject {
		return client.bind(this)
	}

	fun unbind(): VertexArrayObject {
		return client.unbind(this)
	}

	fun attribute(position: Int, size: Int, type: Int, normalize: Boolean, stride: Int, offset: Long = 0L): VertexArrayObject {
		client.ensureSameThread()
		glVertexAttribPointer(position, size, type, normalize, stride, offset)
		checkForGLError()
		return this
	}

	fun enableAttribute(position: Int): VertexArrayObject {
		client.ensureSameThread()
		glEnableVertexArrayAttrib(pointer, position)
		//glEnableVertexAttribArray(position)
		checkForGLError()
		return this
	}
}
