package ru.dbotthepony.kstarbound.client.gl.properties

import org.lwjgl.opengl.GL11.GL_TEXTURE_2D
import org.lwjgl.opengl.GL11.glBindTexture
import ru.dbotthepony.kstarbound.client.StarboundClient
import ru.dbotthepony.kstarbound.client.gl.GLTexture2D
import ru.dbotthepony.kstarbound.client.gl.checkForGLError
import kotlin.properties.ReadWriteProperty
import kotlin.reflect.KProperty

class TexturesTracker(maxValue: Int) : ReadWriteProperty<StarboundClient, GLTexture2D?> {
	private val values = arrayOfNulls<GLTexture2D>(maxValue)

	override fun getValue(thisRef: StarboundClient, property: KProperty<*>): GLTexture2D? {
		return values[thisRef.activeTexture]
	}

	override fun setValue(thisRef: StarboundClient, property: KProperty<*>, value: GLTexture2D?) {
		thisRef.ensureSameThread()

		require(value == null || thisRef === value.client) { "$value does not belong to $thisRef" }

		if (values[thisRef.activeTexture] === value) {
			return
		}

		values[thisRef.activeTexture] = value

		if (value == null) {
			glBindTexture(GL_TEXTURE_2D, 0)
			checkForGLError()
			return
		}

		glBindTexture(GL_TEXTURE_2D, value.pointer)
		checkForGLError()
	}
}
